﻿Imports System.Management

Module Module1
    Sub Main()
        Dim strUser As String = ""
        Dim strPass As String = ""
        Dim objManagementScope As ManagementScope = ConnectManagementScope("win2008r2.local", strUser, strPass)
        'Call DefineVM(objManagementScope, "VM01", "D:\Hyper-V\VM01")
        'Call SetDynamicMemory(objManagementScope, "VM01", 1024)
        Call SetProcessor(objManagementScope, "VM01", 2)
    End Sub

    Function ConnectManagementScope(ByVal strServer As String, ByVal strAccount As String, ByVal strPassword As String) As ManagementScope
        Dim objConnectionOptions As New ConnectionOptions()
        objConnectionOptions.Impersonation = ImpersonationLevel.Impersonate 'WMI への接続に使用される偽装レベルを設定
        objConnectionOptions.EnablePrivileges = True 'WNI経由の操作のためにユーザー特権を有効にする
        objConnectionOptions.Username = strAccount
        objConnectionOptions.Password = strPassword
        Dim objManagementScope As New ManagementScope("\\" + strServer + "\root\virtualization", objConnectionOptions)
        objManagementScope.Connect()
        Return (objManagementScope)
    End Function

    Function ConnectManagementScope() As ManagementScope
        Dim objManagementScope As New ManagementScope("\\.\root\virtualization")
        objManagementScope.Connect()
        Return (objManagementScope)
    End Function

    Sub GetVMList(ByVal objManagementScope As ManagementScope)
        Dim objObjectQuery As New ObjectQuery("SELECT * FROM Msvm_ComputerSystem WHERE Caption LIKE '仮想マシン'")
        Dim objManagementObjectSearcher As New ManagementObjectSearcher(objManagementScope, objObjectQuery)
        Dim objManagementObjectCollection As ManagementObjectCollection = objManagementObjectSearcher.Get
        For Each objManagementObject As ManagementObject In objManagementObjectCollection
            Console.WriteLine(objManagementObject("ElementName"))
        Next
    End Sub

    Function DefineVM(ByVal objManagementScope As ManagementScope, ByVal strVMName As String, ByVal strFolderPath As String) As Boolean
        Dim objVirtualSystemGlobalsettingData As New ManagementClass(objManagementScope, New ManagementPath("Msvm_VirtualSystemGlobalsettingData"), Nothing)
        Dim objVirtualSystemGlobalsettingDataInstance As ManagementObject = objVirtualSystemGlobalsettingData.CreateInstance
        objVirtualSystemGlobalsettingDataInstance("ElementName") = strVMName
        objVirtualSystemGlobalsettingDataInstance("ExternalDataRoot") = strFolderPath
        Dim strSystemsettingData As String = objVirtualSystemGlobalsettingDataInstance.GetText(TextFormat.CimDtd20)

        For Each objVirtualSystemManagementService As ManagementObject In New ManagementObjectSearcher(objManagementScope, New ObjectQuery("SELECT * FROM Msvm_VirtualSystemManagementService")).Get
            Dim objParams As ManagementBaseObject = objVirtualSystemManagementService.GetMethodParameters("DefineVirtualSystem")
            objParams("ResourceSettingData") = Nothing
            objParams("Sourcesetting") = Nothing
            objParams("SystemsettingData") = strSystemsettingData
            Dim objManagementBaseObject As ManagementBaseObject = objVirtualSystemManagementService.InvokeMethod("DefineVirtualSystem", objParams, Nothing)
            Return JobComplete(objManagementBaseObject, objManagementScope)
        Next
    End Function

    Function SetDynamicMemory(ByVal objManagementScope As ManagementScope, ByVal strVMName As String, ByVal intMemory As Integer) As Boolean
        Dim objComputerSystem As ManagementObject = Nothing
        For Each objManagementObject As ManagementObject In New ManagementObjectSearcher(objManagementScope, New ObjectQuery("SELECT * FROM Msvm_ComputerSystem WHERE ElementName = '" & strVMName & "'")).Get
            objComputerSystem = objManagementObject
        Next

        Dim objVirtualSystemSettingData As ManagementObject = Nothing
        For Each objManagementObject As ManagementObject In New ManagementObjectSearcher(objManagementScope, New ObjectQuery("SELECT * FROM Msvm_VirtualSystemSettingData WHERE ElementName = '" & strVMName & "'")).Get
            objVirtualSystemSettingData = objManagementObject
        Next

        Dim strMemorySettingData As String = ""
        Dim objMemorySettingDataCollection As ManagementObjectCollection = objVirtualSystemSettingData.GetRelated("Msvm_MemorySettingData")
        For Each objManagementObject As ManagementObject In objMemorySettingDataCollection
            objManagementObject("DynamicMemoryEnabled") = True
            objManagementObject("VirtualQuantity") = intMemory
            objManagementObject("Limit") = 4096
            objManagementObject("TargetMemoryBuffer") = 20
            objManagementObject("Weight") = 5000
            objManagementObject("Reservation") = intMemory
            strMemorySettingData = objManagementObject.GetText(TextFormat.CimDtd20)
        Next

        For Each objVirtualSystemManagementService As ManagementObject In New ManagementObjectSearcher(objManagementScope, New ObjectQuery("SELECT * FROM Msvm_VirtualSystemManagementService")).Get
            Dim objParams As ManagementBaseObject = objVirtualSystemManagementService.GetMethodParameters("ModifyVirtualSystemResources")
            objParams("ResourceSettingData") = New String() {strMemorySettingData}
            objParams("ComputerSystem") = objComputerSystem.Path.Path
            Dim objManagementBaseObject As ManagementBaseObject = objVirtualSystemManagementService.InvokeMethod("ModifyVirtualSystemResources", objParams, Nothing)
            Return JobComplete(objManagementBaseObject, objManagementScope)
        Next
    End Function

    Function SetStaticMemory(ByVal objManagementScope As ManagementScope, ByVal strVMName As String, ByVal intMemory As Integer) As Boolean
        Dim objComputerSystem As ManagementObject = Nothing
        For Each objManagementObject As ManagementObject In New ManagementObjectSearcher(objManagementScope, New ObjectQuery("SELECT * FROM Msvm_ComputerSystem WHERE ElementName = '" & strVMName & "'")).Get
            objComputerSystem = objManagementObject
        Next

        Dim objVirtualSystemSettingData As ManagementObject = Nothing
        For Each objManagementObject As ManagementObject In New ManagementObjectSearcher(objManagementScope, New ObjectQuery("SELECT * FROM Msvm_VirtualSystemSettingData WHERE ElementName = '" & strVMName & "'")).Get
            objVirtualSystemSettingData = objManagementObject
        Next

        Dim strMemorySettingData As String = ""
        Dim objMemorySettingDataCollection As ManagementObjectCollection = objVirtualSystemSettingData.GetRelated("Msvm_MemorySettingData")
        For Each objManagementObject As ManagementObject In objMemorySettingDataCollection
            objManagementObject("VirtualQuantity") = intMemory
            strMemorySettingData = objManagementObject.GetText(TextFormat.CimDtd20)
        Next

        For Each objVirtualSystemManagementService As ManagementObject In New ManagementObjectSearcher(objManagementScope, New ObjectQuery("SELECT * FROM Msvm_VirtualSystemManagementService")).Get
            Dim objParams As ManagementBaseObject = objVirtualSystemManagementService.GetMethodParameters("ModifyVirtualSystemResources")
            objParams("ResourceSettingData") = New String() {strMemorySettingData}
            objParams("ComputerSystem") = objComputerSystem.Path.Path
            Dim objManagementBaseObject As ManagementBaseObject = objVirtualSystemManagementService.InvokeMethod("ModifyVirtualSystemResources", objParams, Nothing)
            Return JobComplete(objManagementBaseObject, objManagementScope)
        Next
    End Function

    Function SetProcessor(ByVal objManagementScope As ManagementScope, ByVal strVMName As String, ByVal intProcessor As Integer) As Boolean
        Dim objComputerSystem As ManagementObject = Nothing
        For Each objManagementObject As ManagementObject In New ManagementObjectSearcher(objManagementScope, New ObjectQuery("SELECT * FROM Msvm_ComputerSystem WHERE ElementName = '" & strVMName & "'")).Get
            objComputerSystem = objManagementObject
        Next

        Dim objVirtualSystemsettingData As ManagementObject = Nothing
        For Each objManagementObject As ManagementObject In objComputerSystem.GetRelated("Msvm_VirtualSystemsettingData")
            objVirtualSystemsettingData = objManagementObject
        Next

        Dim objProcessorSettingData As ManagementObject = Nothing
        For Each objManagementObject As ManagementObject In objVirtualSystemsettingData.GetRelated("Msvm_ProcessorSettingData")
            objProcessorSettingData = objManagementObject
            objProcessorSettingData("VirtualQuantity") = intProcessor
        Next

        For Each objVirtualSystemManagementService As ManagementObject In New ManagementObjectSearcher(objManagementScope, New ObjectQuery("SELECT * FROM Msvm_VirtualSystemManagementService")).Get
            Dim objParams As ManagementBaseObject = objVirtualSystemManagementService.GetMethodParameters("ModifyVirtualSystemResources")
            Dim strResourceSettingData As String() = New String(0) {}
            strResourceSettingData(0) = objProcessorSettingData.GetText(TextFormat.CimDtd20)
            objParams("ResourceSettingData") = strResourceSettingData
            objParams("ComputerSystem") = objComputerSystem.Path.Path
            Dim objManagementBaseObject As ManagementBaseObject = objVirtualSystemManagementService.InvokeMethod("ModifyVirtualSystemResources", objParams, Nothing)
            Return JobComplete(objManagementBaseObject, objManagementScope)
        Next
    End Function


    Function JobComplete(ByVal objManagementBaseObject As ManagementBaseObject, ByVal objManagementScope As ManagementScope) As Boolean
        'JobState New = 2  Starting = 3  Running = 4  Suspended = 5  ShuttingDown = 6  Completed = 7  Terminated = 8  Killed = 9  Exception = 10  Service = 11
        If objManagementBaseObject("ReturnValue") <> 0 Then
            Dim strJobPath As String = objManagementBaseObject("Job")
            Dim objJob As New ManagementObject(objManagementScope, New ManagementPath(strJobPath), Nothing)
            objJob.Get()
            Do While objJob("JobState") = 3 Or objJob("JobState") = 4
                System.Threading.Thread.Sleep(1000)
                objJob.Get()
            Loop
            If objJob("JobState") <> 7 Then
                Console.WriteLine("ErrorCode=" & objJob("ErrorCode") & " JobState=" & objJob("JobState"))
                Return False
            Else
                Return True
            End If
        Else
            Return True
        End If
    End Function

End Module
